Index: /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/AbsoluteErrorLoss.cs
===================================================================
--- /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/AbsoluteErrorLoss.cs	(revision 12876)
+++ /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/AbsoluteErrorLoss.cs	(revision 12877)
@@ -31,5 +31,5 @@
   [StorableClass]
   [Item("Absolute error loss", "")]
-  public class AbsoluteErrorLoss : Item, ILossFunction {
+  public sealed class AbsoluteErrorLoss : Item, ILossFunction {
     public AbsoluteErrorLoss() { }
 
@@ -82,4 +82,7 @@
 
     #region item implementation
+    [StorableConstructor]
+    private AbsoluteErrorLoss(bool deserializing) : base(deserializing) { }
+
     private AbsoluteErrorLoss(AbsoluteErrorLoss original, Cloner cloner) : base(original, cloner) { }
 
Index: /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/LogisticRegressionLoss.cs
===================================================================
--- /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/LogisticRegressionLoss.cs	(revision 12876)
+++ /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/LogisticRegressionLoss.cs	(revision 12877)
@@ -33,5 +33,5 @@
   [StorableClass]
   [Item("Logistic regression loss", "")]
-  public class LogisticRegressionLoss : Item, ILossFunction {
+  public sealed class LogisticRegressionLoss : Item, ILossFunction {
     public LogisticRegressionLoss() { }
 
@@ -90,4 +90,7 @@
 
     #region item implementation
+    [StorableConstructor]
+    private LogisticRegressionLoss(bool deserializing) : base(deserializing) { }
+
     private LogisticRegressionLoss(LogisticRegressionLoss original, Cloner cloner) : base(original, cloner) { }
 
Index: /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/RelativeErrorLoss.cs
===================================================================
--- /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/RelativeErrorLoss.cs	(revision 12876)
+++ /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/RelativeErrorLoss.cs	(revision 12877)
@@ -33,5 +33,5 @@
   [StorableClass]
   [Item("Relative error loss", "")]
-  public class RelativeErrorLoss : Item, ILossFunction {
+  public sealed class RelativeErrorLoss : Item, ILossFunction {
     public RelativeErrorLoss() { }
 
@@ -112,4 +112,7 @@
 
     #region item implementation
+    [StorableConstructor]
+    private RelativeErrorLoss(bool deserializing) : base(deserializing) { }
+
     private RelativeErrorLoss(RelativeErrorLoss original, Cloner cloner) : base(original, cloner) { }
 
Index: /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/SquaredErrorLoss.cs
===================================================================
--- /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/SquaredErrorLoss.cs	(revision 12876)
+++ /branches/crossvalidation-2434/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/SquaredErrorLoss.cs	(revision 12877)
@@ -31,5 +31,5 @@
   [StorableClass]
   [Item("Squared error loss", "")]
-  public class SquaredErrorLoss : Item, ILossFunction {
+  public sealed class SquaredErrorLoss : Item, ILossFunction {
     public SquaredErrorLoss() { }
 
@@ -78,4 +78,7 @@
 
     #region item implementation
+    [StorableConstructor]
+    private SquaredErrorLoss(bool deserializing) : base(deserializing) { }
+
     private SquaredErrorLoss(SquaredErrorLoss original, Cloner cloner) : base(original, cloner) { }
 