Index: /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 12888)
+++ /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 12889)
@@ -33,5 +33,5 @@
 
     private List<List<string>> columnsRowsMatrix;
-    private readonly int COLUMNS = 10;
+    private readonly int COLUMNS = 12;
 
     public new StatisticsContent Content {
@@ -83,5 +83,5 @@
 
       columnsRowsMatrix = new List<List<string>>();
-      DataGridViewColumn[] columns = new DataGridViewColumn[10];
+      DataGridViewColumn[] columns = new DataGridViewColumn[COLUMNS];
       for (int i = 0; i < COLUMNS; ++i) {
         var column = new DataGridViewTextBoxColumn();
@@ -99,6 +99,8 @@
       columns[6].HeaderCell.Value = "std. Deviation";
       columns[7].HeaderCell.Value = "Variance";
-      columns[8].HeaderCell.Value = "Most Common Value";
-      columns[9].HeaderCell.Value = "Num. diff. Values";
+      columns[8].HeaderCell.Value = "25th Percentile";
+      columns[9].HeaderCell.Value = "75th Percentile";
+      columns[10].HeaderCell.Value = "Most Common Value";
+      columns[11].HeaderCell.Value = "Num. diff. Values";
 
       if (rowCount > 0) {
@@ -150,4 +152,6 @@
         logic.GetStandardDeviation(columnIndex).ToString(),
         logic.GetVariance(columnIndex).ToString(),
+        logic.GetOneQuarterPercentile(columnIndex).ToString(),
+        logic.GetThreeQuarterPercentile(columnIndex).ToString(),
         logic.GetMostCommonValue<double>(columnIndex).ToString(),
         logic.GetDifferentValuesCount<double>(columnIndex).ToString()
@@ -166,4 +170,6 @@
         "", //standard deviation
         "", //variance
+        "", //quarter percentile
+        "", //three quarter percentile
         logic.GetMostCommonValue<string>(columnIndex) ?? "",
         logic.GetDifferentValuesCount<string>(columnIndex).ToString()
@@ -178,8 +184,10 @@
         logic.GetMin<DateTime>(columnIndex).ToString(),
         logic.GetMax<DateTime>(columnIndex).ToString(),
-        logic.GetMedianDateTime(columnIndex).ToString(), 
+        logic.GetMedianDateTime(columnIndex).ToString(),
         logic.GetAverageDateTime(columnIndex).ToString(),
         logic.GetStandardDeviation(columnIndex).ToString(),
         logic.GetVariance(columnIndex).ToString(), //variance
+        logic.GetOneQuarterPercentile(columnIndex).ToString(),
+        logic.GetThreeQuarterPercentile(columnIndex).ToString(),
         logic.GetMostCommonValue<DateTime>(columnIndex).ToString(),
         logic.GetDifferentValuesCount<DateTime>(columnIndex).ToString()
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Implementations/StatisticsLogic.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Implementations/StatisticsLogic.cs	(revision 12888)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Implementations/StatisticsLogic.cs	(revision 12889)
@@ -163,4 +163,24 @@
     }
 
+    public double GetOneQuarterPercentile(int columnIndex) {
+      double percentile = double.NaN;
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        percentile = GetValuesWithoutNaN<double>(columnIndex).Percentile(0.25);
+      } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        percentile = GetDateTimeAsSeconds(columnIndex).Percentile(0.25);
+      }
+      return percentile;
+    }
+
+    public double GetThreeQuarterPercentile(int columnIndex) {
+      double percentile = double.NaN;
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        percentile = GetValuesWithoutNaN<double>(columnIndex).Percentile(0.75);
+      } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        percentile = GetDateTimeAsSeconds(columnIndex).Percentile(0.75);
+      }
+      return percentile;
+    }
+
     public int GetDifferentValuesCount<T>(int columnIndex) {
       return preprocessingData.GetValues<T>(columnIndex).GroupBy(x => x).Count();
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Interfaces/IStatisticsLogic.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Interfaces/IStatisticsLogic.cs	(revision 12888)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Interfaces/IStatisticsLogic.cs	(revision 12889)
@@ -41,4 +41,6 @@
     DateTime GetAverageDateTime(int columnIndex, bool considerSelection = false);
 
+    double GetOneQuarterPercentile(int columnIndex);
+    double GetThreeQuarterPercentile(int columnIndex);
     double GetStandardDeviation(int columnIndex);
     double GetVariance(int columnIndex);